/*
 * File: app.js
 *
 * This file was generated by Sencha Architect version 2.0.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Sencha Touch 2.0.x library, under independent license.
 * License of Sencha Architect does not include license for Sencha Touch 2.0.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.Loader.setConfig({
    enabled: true,
    paths: {
        'Ext.device': 'device/'
    }
});

Ext.application({
    requires: [
        'Ext.device.Camera'
    ],

    models: [
        'Contact',
        'Group'
    ],
    stores: [
        'ContactStore',
        'GroupStore'
    ],
    views: [
        'Main',
        'Info',
        'Form',
        'Picture',
        'ContactList',
        'FavoriteView',
        'GroupList',
        'ContactOrder'
    ],
    name: 'Contact',
    controllers: [
        'Contacts'
    ],

    launch: function() {
        Ext.require('Ext.device.*');
        Ext.util.Format.empty = function(value, defaultValue) {
            return !Ext.isEmpty(value) ? value : defaultValue;
        };
        Ext.util.Format.undef = function(value, defaultValue) {
            return Ext.isDefined(value) ? value : defaultValue;
        };
        var cs = Ext.StoreMgr.lookup('ContactStore');
        var gs = Ext.StoreMgr.lookup('GroupStore');
        if (!cs.getCount() || !gs.getCount()) {
            Ext.Msg.alert('Intro', 'Setting up default database.');
            // Add demo contacts
            cs.add({
                firstName: 'Aaron',
                lastName: 'Conran',
                emailAddress: 'aaron@sencha.com',
                phoneNumber: '443-555-1234',
                group: 'Sencha'
            });
            cs.add({
                firstName: 'Aditya',
                lastName: 'Bansod',
                phoneNumber: '555-555-1234',
                group: 'Sencha'
            });
            cs.add({
                firstName: 'Luca',
                lastName: 'Candela',
                phoneNumber: '555-555-1234',
                group: 'Sencha'
            });
            cs.add({
                firstName: 'Tommy',
                lastName: 'Maintz',
                isFavorite: true,
                phoneNumber: '717-555-1234',
                group: 'Sencha'
            });
            cs.add({
                firstName: 'Nige',
                lastName: '(Animal) White',
                isFavorite: true,
                phoneNumber: '555-555-1234',
                group: 'Sencha'
            });
            cs.add({
                firstName: 'Osvaldo',
                lastName: 'Brignoni',
                phoneNumber: '555-555-1234',
                group: 'Github'
            });
            cs.add({
                firstName: 'Tom',
                lastName: 'Hanks',
                phoneNumber: '555-555-1234',
                group: 'Movie Stars'
            });
            cs.add({
                firstName: 'Julia',
                lastName: 'Roberts',
                phoneNumber: '555-555-1234',
                group: 'Movie Stars'
            });
            //Add demo groups
            gs.add({
                name: 'Contacts' // Default group
            });
            gs.add({
                name: 'Github'
            });
            gs.add({
                name: 'Movie Stars'
            });
            gs.add({
                name: 'Sencha'
            });
        }
        Ext.create('Contact.view.Main', {fullscreen: true});
    }

});
